#!/bin/bash

#---------------------------------------------------------------------------------
# Create FBA lists
#---------------------------------------------------------------------------------
echo
echo "Creating FBA lists..."
echo


#: <<'END_COMMENT'
mkdir FBA_LISTS

grep "|CAPCOM$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/CAPCOM.txt
grep "|CAPCOM CPS 1$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/CPS1.txt
grep "|CAPCOM CPS 2$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/CPS2.txt

grep "|CAVE$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/CAVE.txt
grep "|DATA EAST$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/DATA_EAST.txt
grep "|GALAXIAN$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/GALAXIAN.txt
grep "|IREM$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/IREM.txt
grep "|KANEKO$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/KANEKO.txt
grep "|KONAMI$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/KONAMI.txt
grep "|MISC (POST 90)$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/POST_90.txt
grep "|MISC (PRE 90)$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/PRE_90.txt
grep "|PACMAN$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/PACMAN.txt
grep "|PGM$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/PGM.txt
grep "|PSIKYO$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/PSIKYO.txt
grep "|SEGA$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/SEGA.txt
grep "|SETA$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/SETA.txt
grep "|TAITO$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/TAITO.txt
grep "|TECHNOS$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/TECHNOS.txt
grep "|TOAPLAN$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/TOAPLAN.txt
grep "|TAITO$" FBA_WORKING_NOCLONES_NONEOGEO.csv  | cut -d "|" -f1 > ./FBA_LISTS/TAITO.txt

# Neogeo lists
grep "|NEOGEO$" FBA_ALL.csv  | cut -d "|" -f1 > ./FBA_LISTS/NEOGEO_FBA.txt
grep "GAMEB(" neogeo.c  | cut -d "," -f2 | sed "s/ //g" | sed "s/$/\.zip/g"  > NEOGEO_MAME2003.txt


#---------------------------------------------------------------------------------
# Create Compatibility list without clones
#---------------------------------------------------------------------------------
echo
echo "Creating compatibility list..."
echo

rm MAME2003_RPI_COMPAT.txt

while read line
do
    NAME=`echo $line | cut -d "|" -f1`
    CLONE=`echo $line | cut -d "|" -f3`
    STATE=`echo $line | cut -d "|" -f2`

    if grep -q "^${NAME}.zip" NEOGEO_MAME2003.txt ||  grep -q "^${NAME}.zip" ./FBA_LISTS/NEOGEO_FBA.txt; then
        echo "$NAME NEOGEO!"
    else
        if [[ "$CLONE" == "" ]]; then
            echo "${NAME}.zip|$STATE" >> MAME2003_RPI_COMPAT.txt
        fi
    fi
done < MAME2003_RPI_ALL.txt

#---------------------------------------------------------------------------------
# Create Mame2003 lists based on game's status
#---------------------------------------------------------------------------------
echo
echo "Creating Mame2003 lists..."
echo

rm MAME2003_NOCLONES/*
rm MAME2003_ALL/*
mkdir MAME2003_NOCLONES
mkdir MAME2003_ALL

TOTAL=0

for index in A B C D E F G ; do
    echo
    echo "## Sorting core${index} ... ##"
    echo

    while read line
    do
        if grep -q "^$line|" FBA_WORKING_NOCLONES_NONEOGEO.csv; then
            echo "$line Working in FBA!"
        else
            if grep -q "^$line|" MAME2003_RPI_COMPAT.txt; then
                NAME=`grep  "^$line|" MAME2003_RPI_COMPAT.txt | cut -d "|" -f1`
                STATE=`grep  "^$line|" MAME2003_RPI_COMPAT.txt| cut -d "|" -f2`
                #echo "$NAME||$STATE"

                if [[ "$STATE" == "Doesn't Work" ]]; then
                    echo "$line" >> ./MAME2003_NOCLONES/core${index}_NotWorking.txt
                elif  [[ "$STATE" == "Has Issues" ]]; then
                    echo "$line" >> ./MAME2003_NOCLONES/core${index}_Issues.txt
                elif  [[ "$STATE" == "OK" ]]; then
                    echo "$line" >> ./MAME2003_NOCLONES/core${index}.txt
                elif  [[ "$STATE" == "Untested" ]]; then
                    echo "$line" >> ./MAME2003_NOCLONES/core${index}_Untested.txt
                else
                    echo "$line" >> ./MAME2003_NOCLONES/core${index}_Untested.txt
                fi
            fi
        fi
    done < core${index}.txt

    TMP=`cat ./MAME2003_NOCLONES/core${index}.txt | wc -l `
    TOTAL=$((TOTAL+TMP))
done

echo
echo "Games possibly working: $TOTAL"
echo

#END_COMMENT

#---------------------------------------------------------------------------------
# Create Mame2000 lists based on game's status
#---------------------------------------------------------------------------------

rm MAME2003_Issues.txt
rm MAME2003_NOT_WORKING.txt
rm MAME2003_UNTESTED.txt

    for index in A B C D E F G ; do
        cat  ./MAME2003_NOCLONES/core${index}_Issues.txt >> MAME2003_Issues.txt
        cat  ./MAME2003_NOCLONES/core${index}_NotWorking.txt >> MAME2003_NOT_WORKING.txt
        cat  ./MAME2003_NOCLONES/core${index}_Untested.txt >> MAME2003_UNTESTED.txt
    done

echo
echo "MAME2000 Issues in MAME2003.."
echo

    while read line
    do
        NAME2000=`echo $line | sed "s/\.zip//g"`

            if grep -q "^$NAME2000|" Mame2000.csv; then
                NAME=`grep  "^$NAME2000|" Mame2000.csv | cut -d "|" -f1`
                STATE=`grep  "^$NAME2000|" Mame2000.csv| cut -d "|" -f3`

                if [[ "$STATE" == "OK" ]]; then
                    echo "$line OK" 
                    echo "$line" >> Mame2000OK_NoMame2003.txt
                else
                    :
                fi
            fi
    done < MAME2003_Issues.txt

echo
echo "MAME2000 Not working in MAME2003.."
echo

    while read line
    do
        NAME2000=`echo $line | sed "s/\.zip//g"`

            if grep -q "^$NAME2000|" Mame2000.csv; then
                NAME=`grep  "^$NAME2000|" Mame2000.csv | cut -d "|" -f1`
                STATE=`grep  "^$NAME2000|" Mame2000.csv| cut -d "|" -f3`

                if [[ "$STATE" == "OK" ]]; then
                    echo "$line OK"
                    echo "$line" >> Mame2000OK_NoMame2003.txt
                else
                    :
                fi
            fi
    done < MAME2003_NOT_WORKING.txt

echo
echo "MAME2000 Untested in MAME2003.."
echo

    while read line
    do
        NAME2000=`echo $line | sed "s/\.zip//g"`

            if grep -q "^$NAME2000|" Mame2000.csv; then
                NAME=`grep  "^$NAME2000|" Mame2000.csv | cut -d "|" -f1`
                STATE=`grep  "^$NAME2000|" Mame2000.csv| cut -d "|" -f3`

                if [[ "$STATE" == "OK" ]]; then
                    echo "$line OK"
                    echo "$line" >> Mame2000OK_NoMame2003.txt
                else
                :
                fi
            fi
    done < MAME2003_UNTESTED.txt

